import{IdentityClient}from"../../client/identityClient";import{AuthenticationError,AuthenticationRequiredError,CredentialUnavailableError}from"../../errors";import{credentialLogger,formatError,formatSuccess}from"../../util/logging";import{appServiceMsi2017}from"./appServiceMsi2017";import{tracingClient}from"../../util/tracing";import{cloudShellMsi}from"./cloudShellMsi";import{imdsMsi}from"./imdsMsi";import{arcMsi}from"./arcMsi";import{tokenExchangeMsi}from"./tokenExchangeMsi";import{fabricMsi}from"./fabricMsi";import{appServiceMsi2019}from"./appServiceMsi2019";import{ConfidentialClientApplication}from"@azure/msal-node";import{DeveloperSignOnClientId}from"../../constants";import{getMSALLogLevel}from"../../msal/utils";import{getLogLevel}from"@azure/logger";const logger=credentialLogger("ManagedIdentityCredential");export class ManagedIdentityCredential{constructor(e,t){var n;let i;if(this.isEndpointUnavailable=null,this.isAppTokenProviderInitialized=!1,"string"==typeof e?(this.clientId=e,i=t):(this.clientId=null==e?void 0:e.clientId,i=e),this.resourceId=null==i?void 0:i.resourceId,this.clientId&&this.resourceId)throw new Error(`${ManagedIdentityCredential.name} - Client Id and Resource Id can't be provided at the same time.`);this.identityClient=new IdentityClient(i),this.isAvailableIdentityClient=new IdentityClient(Object.assign(Object.assign({},i),{retryOptions:{maxRetries:0}})),this.confidentialApp=new ConfidentialClientApplication({auth:{authority:"https://login.microsoftonline.com/managed_identity",clientId:null!==(n=this.clientId)&&void 0!==n?n:DeveloperSignOnClientId,clientSecret:"dummy-secret",cloudDiscoveryMetadata:'{"tenant_discovery_endpoint":"https://login.microsoftonline.com/common/v2.0/.well-known/openid-configuration","api-version":"1.1","metadata":[{"preferred_network":"login.microsoftonline.com","preferred_cache":"login.windows.net","aliases":["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{"preferred_network":"login.partner.microsoftonline.cn","preferred_cache":"login.partner.microsoftonline.cn","aliases":["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{"preferred_network":"login.microsoftonline.de","preferred_cache":"login.microsoftonline.de","aliases":["login.microsoftonline.de"]},{"preferred_network":"login.microsoftonline.us","preferred_cache":"login.microsoftonline.us","aliases":["login.microsoftonline.us","login.usgovcloudapi.net"]},{"preferred_network":"login-us.microsoftonline.com","preferred_cache":"login-us.microsoftonline.com","aliases":["login-us.microsoftonline.com"]}]}',authorityMetadata:'{"token_endpoint":"https://login.microsoftonline.com/common/oauth2/v2.0/token","token_endpoint_auth_methods_supported":["client_secret_post","private_key_jwt","client_secret_basic"],"jwks_uri":"https://login.microsoftonline.com/common/discovery/v2.0/keys","response_modes_supported":["query","fragment","form_post"],"subject_types_supported":["pairwise"],"id_token_signing_alg_values_supported":["RS256"],"response_types_supported":["code","id_token","code id_token","id_token token"],"scopes_supported":["openid","profile","email","offline_access"],"issuer":"https://login.microsoftonline.com/{tenantid}/v2.0","request_uri_parameter_supported":false,"userinfo_endpoint":"https://graph.microsoft.com/oidc/userinfo","authorization_endpoint":"https://login.microsoftonline.com/common/oauth2/v2.0/authorize","device_authorization_endpoint":"https://login.microsoftonline.com/common/oauth2/v2.0/devicecode","http_logout_supported":true,"frontchannel_logout_supported":true,"end_session_endpoint":"https://login.microsoftonline.com/common/oauth2/v2.0/logout","claims_supported":["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],"kerberos_endpoint":"https://login.microsoftonline.com/common/kerberos","tenant_region_scope":null,"cloud_instance_name":"microsoftonline.com","cloud_graph_host_name":"graph.windows.net","msgraph_host":"graph.microsoft.com","rbac_url":"https://pas.windows.net"}',clientCapabilities:[]},system:{loggerOptions:{logLevel:getMSALLogLevel(getLogLevel())}}})}async cachedAvailableMSI(e,t){if(this.cachedMSI)return this.cachedMSI;const n=[arcMsi,fabricMsi,appServiceMsi2019,appServiceMsi2017,cloudShellMsi,tokenExchangeMsi(),imdsMsi];for(const i of n)if(await i.isAvailable({scopes:e,identityClient:this.isAvailableIdentityClient,clientId:this.clientId,resourceId:this.resourceId,getTokenOptions:t}))return this.cachedMSI=i,i;throw new CredentialUnavailableError(`${ManagedIdentityCredential.name} - No MSI credential available`)}async authenticateManagedIdentity(e,t){const{span:n,updatedOptions:i}=tracingClient.startSpan(`${ManagedIdentityCredential.name}.authenticateManagedIdentity`,t);try{return(await this.cachedAvailableMSI(e,i)).getToken({identityClient:this.identityClient,scopes:e,clientId:this.clientId,resourceId:this.resourceId},i)}catch(e){throw n.setStatus({status:"error",error:e}),e}finally{n.end()}}async getToken(e,t){let n=null;const{span:i,updatedOptions:o}=tracingClient.startSpan(`${ManagedIdentityCredential.name}.getToken`,t);try{if(!0===this.isEndpointUnavailable){const t=new CredentialUnavailableError("The managed identity endpoint is not currently available");throw logger.getToken.info(formatError(e,t)),t}if("tokenExchangeMsi"===(await this.cachedAvailableMSI(e,o)).name)n=await this.authenticateManagedIdentity(e,o);else{const i={correlationId:this.identityClient.getCorrelationId(),tenantId:(null==t?void 0:t.tenantId)||"managed_identity",scopes:Array.isArray(e)?e:[e],claims:null==t?void 0:t.claims};this.initializeSetAppTokenProvider();const o=await this.confidentialApp.acquireTokenByClientCredential(Object.assign({},i));n=this.handleResult(e,o||void 0)}if(null===n){this.isEndpointUnavailable=!0;const t=new CredentialUnavailableError("The managed identity endpoint was reached, yet no tokens were received.");throw logger.getToken.info(formatError(e,t)),t}this.isEndpointUnavailable=!1;return logger.getToken.info(formatSuccess(e)),n}catch(t){if("AuthenticationRequiredError"===t.name)throw t;if(i.setStatus({status:"error",error:t}),"ENETUNREACH"===t.code){const n=new CredentialUnavailableError(`${ManagedIdentityCredential.name}: Unavailable. Network unreachable. Message: ${t.message}`);throw logger.getToken.info(formatError(e,n)),n}if("EHOSTUNREACH"===t.code){const n=new CredentialUnavailableError(`${ManagedIdentityCredential.name}: Unavailable. No managed identity endpoint found. Message: ${t.message}`);throw logger.getToken.info(formatError(e,n)),n}if(400===t.statusCode)throw new CredentialUnavailableError(`${ManagedIdentityCredential.name}: The managed identity endpoint is indicating there's no available identity. Message: ${t.message}`);if((403===t.statusCode||403===t.code)&&t.message.includes("A socket operation was attempted to an unreachable network")){const n=new CredentialUnavailableError(`${ManagedIdentityCredential.name}: Unavailable. Network unreachable. Message: ${t.message}`);throw logger.getToken.info(formatError(e,n)),n}if(void 0===t.statusCode)throw new CredentialUnavailableError(`${ManagedIdentityCredential.name}: Authentication failed. Message ${t.message}`);throw new AuthenticationError(t.statusCode,{error:`${ManagedIdentityCredential.name} authentication failed.`,error_description:t.message})}finally{i.end()}}handleResult(e,t,n){return this.ensureValidMsalToken(e,t,n),logger.getToken.info(formatSuccess(e)),{token:t.accessToken,expiresOnTimestamp:t.expiresOn.getTime()}}ensureValidMsalToken(e,t,n){const i=t=>(logger.getToken.info(t),new AuthenticationRequiredError({scopes:Array.isArray(e)?e:[e],getTokenOptions:n,message:t}));if(!t)throw i("No response");if(!t.expiresOn)throw i('Response had no "expiresOn" property.');if(!t.accessToken)throw i('Response had no "accessToken" property.')}initializeSetAppTokenProvider(){this.isAppTokenProviderInitialized||(this.confidentialApp.SetAppTokenProvider((async e=>{logger.info(`SetAppTokenProvider invoked with parameters- ${JSON.stringify(e)}`);const t=Object.assign({},e);logger.info(`authenticateManagedIdentity invoked with scopes- ${JSON.stringify(e.scopes)} and getTokenOptions - ${JSON.stringify(t)}`);const n=await this.authenticateManagedIdentity(e.scopes,t);if(n){logger.info("SetAppTokenProvider will save the token in cache");const e=(null==n?void 0:n.expiresOnTimestamp)?Math.floor((n.expiresOnTimestamp-Date.now())/1e3):0;return{accessToken:null==n?void 0:n.token,expiresInSeconds:e}}return logger.info('SetAppTokenProvider token has "no_access_token_returned" as the saved token'),{accessToken:"no_access_token_returned",expiresInSeconds:0}})),this.isAppTokenProviderInitialized=!0)}}